<?php

  namespace FiloBlu\PaymentMethodFilter\Plugin\Model\Method;

  use \Magento\Checkout\Model\Session as CheckoutSession;

  class FilterPayment
  {
    protected $checkoutSession;
    protected $_scopeConfig;
    const ENABLE_FILTER_BY_SHIPPING_PATH = 'payment_method_filter/default/enable_filter_carrier';
    const MAPPING_FILTER_BY_SHIPPING_PATH = 'payment_method_filter/default/filter_carrier';

    public function __construct(
      CheckoutSession $checkoutSession,
      \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    )
    {
      $this->checkoutSession = $checkoutSession;
      $this->_scopeConfig = $scopeConfig;
    }

    public function afterGetAvailableMethods(\Magento\Payment\Model\MethodList $subject, $result)
    {
      if($this->_scopeConfig->getValue(SELF::ENABLE_FILTER_BY_SHIPPING_PATH)) {
        $quote = $this->checkoutSession->getQuote();
        $shippingAddress = $quote->getShippingAddress();
        $shippingMethod = $shippingAddress->getShippingMethod();

        $shipping_filter_mapping = $this->_scopeConfig->getValue(SELF::MAPPING_FILTER_BY_SHIPPING_PATH);
        if($shipping_filter_mapping) {
          $mapping = unserialize($shipping_filter_mapping);
          foreach($mapping as $map_id => $field) {
            $shipping_code_filter = $field['shipping_code_filter'];
            if($shippingMethod == $shipping_code_filter) {
              foreach ($result as $key => $_result) {
                if(!in_array($_result->getCode(), $field['payment_code_filter'])) {
                  unset($result[$key]);
                }
              }
            }
          }
        }
      }
      return array_values($result);
    }
  }